import { PISYS } from "pi_sys/index";
import { getDocument } from "pi_gui/main";
import { IScreenInfo } from "../../interface/screen_con";

export class AdaptationManage {
    private static isInit: boolean = false;

    private static screenInfo: IScreenInfo = { sourceWidth: 0, sourceHeight: 0, layoutHeight: 0, layoutWidth: 0, pixelRatio: 0 };

    public static init() {
        if (this.isInit) return;
        const info = PISYS.Env.get("system_info").safeArea;
        // console.log(info);
        const vdocument = getDocument();
        this.screenInfo = {
            sourceWidth: info.width,
            sourceHeight: info.height,
            layoutWidth: info.width * vdocument.pixelRatio,
            layoutHeight: info.height * vdocument.pixelRatio,
            pixelRatio: vdocument.pixelRatio
        }
        this.isInit = true;
    }

    /**
     * 获取当前设备屏幕详情
     */
    public static getScreenInfo(): IScreenInfo {
        this.init();
        return this.screenInfo;
    }
}