import { ModelPrefab } from "pi_babylon/index";
import { ModleBase, IBaseData } from "./model_base";
import { GlobalAtlasManager } from 'pi_babylon/sprite/sprite_atlas';
import { TextureProgressCircleMaterial } from "pi_babylon/material/texture_progress_circle";
import { RES_PATH } from "game_map/xls/map/map.struct";
import { Anim } from 'game_scene_tween_anim/anim';

//显示点击解锁
export class ShowClickCeil extends ModleBase {
    //完成显示
    public modelBg: ModelPrefab;
    //文字图片
    public modelText: ModelPrefab;
    //进度条动画
    private tagId: number = 0;
    private rate = 1;
    public constructor(public data: ProgressData) {
        super(data);
        /**创建背景 */
        this.modelBg = this.createSprite(this.data.icon, "bahuang_dong_0", [57, -1 * 79, 1], this.data.alphaIndex);
        this.modelText = this.createSprite(this.data.textImg, "bahuang_0", [140, -1 * 41, 1], this.data.alphaIndex + 1);
        this.modelText.setPosition(0, 75, 0);
        this.Root.scene.impl.onBeforeRenderObservable.add(this.floatAnima)
    }
    public floatAnima = ()=>{
        let pos = this.modelBg.position;
        if(this.rate > 0 && pos[1] > 20){
            this.rate = -1;
        }else if(this.rate < 0 && pos[1] < 0){
            this.rate = 1;
        }
        pos[1] += 0.2 * this.rate;
        this.modelBg.setPosition(...pos);
    }
    public setParent(root) {
        this.Root.setParent(root);
    }
    public setScale(num) {
        this.Root.setScale(num, num, num);
    }
    public scaleRender(showThumbnail:boolean) {

    }

    //销毁
    public dispose() {
        this.Root.scene.impl.onBeforeRenderObservable.removeCallback(this.floatAnima);
        this.modelBg?.dispose();
        this.modelText?.dispose();
        this.modelBg = undefined;
        this.modelText = undefined;
        Anim.Instance.clearTween(this.tagId);
        super.dispose();
    }
}

export interface ProgressData extends IBaseData {
    icon:string; //完成显示
    textImg:string; //完成文字图片
}
