import { ModelPrefab } from "pi_babylon/index";
import { ModleBase, IBaseData } from "./model_base";

export class PointNum extends ModleBase {
    //背景
    public modelBg: ModelPrefab;
    //数量
    public modelNums: ModelPrefab[] = [];

    public constructor(private data: NumData) {
        super(data);
        this.createNumSprite(this.data.num);
        /**创建背景 */
        if(this.data.bg){
            this.modelBg = this.createSprite(this.data.bg, "bahuang_0", [this.modelNums.length * 18 + 20, -1 * 30, 1], this.data.alphaIndex);
        }
    }
    /**创建数字*/
    public createNumSprite(num: number) {
        let arr = num.toString().split("").reverse(), x = 0;
        let diff = (arr.length + 1)/2;
        arr.forEach((v, i)=>{
            let _x = x + (diff - (i + 1)) * this.data.space;
            let model = this.createSprite( `${this.data.typeName}${v}`, "bahuang_0", [20, -1 * 26, 1], this.data.alphaIndex+1);
            model.setPosition(_x, 0, 0)
            this.modelNums.push(model);
        })
    }
    public setParent(root) {
        this.Root.setParent(root);
    }
    public setScale(scale:number) {
        this.Root.setScale(scale, scale, scale);
    }
    //销毁
    public dispose() {
        this.modelBg?.dispose();
        this.modelNums?.forEach(v=>v.dispose());
        this.modelBg = undefined;
        this.modelNums.length = 0;
        super.dispose();
    }
}

export interface NumData extends IBaseData {
    bg?:string; //背景
    typeName:string,//数字的名称前缀
    num:number,//数字
    space:number,//数字间隔
}

